summaryrefslogtreecommitdiff
path: root/plugins/ssh-agent/ssh-agent.plugin.zsh
diff options
context:
space:
mode:
Diffstat (limited to 'plugins/ssh-agent/ssh-agent.plugin.zsh')
-rw-r--r--plugins/ssh-agent/ssh-agent.plugin.zsh131
1 files changed, 67 insertions, 64 deletions
diff --git a/plugins/ssh-agent/ssh-agent.plugin.zsh b/plugins/ssh-agent/ssh-agent.plugin.zsh
index 610ad34dc..6ab041c21 100644
--- a/plugins/ssh-agent/ssh-agent.plugin.zsh
+++ b/plugins/ssh-agent/ssh-agent.plugin.zsh
@@ -1,79 +1,82 @@
-#
-# INSTRUCTIONS
-#
-# To enable agent forwarding support add the following to
-# your .zshrc file:
-#
-# zstyle :omz:plugins:ssh-agent agent-forwarding on
-#
-# To load multiple identities use the identities style, For
-# example:
-#
-# zstyle :omz:plugins:ssh-agent identities id_rsa id_rsa2 id_github
-#
-# To set the maximum lifetime of the identities, use the
-# lifetime style. The lifetime may be specified in seconds
-# or as described in sshd_config(5) (see TIME FORMATS)
-# If left unspecified, the default lifetime is forever.
-#
-# zstyle :omz:plugins:ssh-agent lifetime 4h
-#
-# CREDITS
-#
-# Based on code from Joseph M. Reagle
-# http://www.cygwin.com/ml/cygwin/2001-06/msg00537.html
-#
-# Agent forwarding support based on ideas from
-# Florent Thoumie and Jonas Pfenniger
-#
+typeset _agent_forwarding _ssh_env_cache
-local _plugin__ssh_env
-local _plugin__forwarding
+function _start_agent() {
+ local lifetime
+ zstyle -s :omz:plugins:ssh-agent lifetime lifetime
-function _plugin__start_agent()
-{
- local -a identities
- local lifetime
- zstyle -s :omz:plugins:ssh-agent lifetime lifetime
+ # start ssh-agent and setup environment
+ echo Starting ssh-agent...
+ ssh-agent -s ${lifetime:+-t} ${lifetime} | sed 's/^echo/#echo/' >! $_ssh_env_cache
+ chmod 600 $_ssh_env_cache
+ . $_ssh_env_cache > /dev/null
+}
+
+function _add_identities() {
+ local id line sig lines
+ local -a identities loaded_sigs loaded_ids not_loaded
+ zstyle -a :omz:plugins:ssh-agent identities identities
+
+ # check for .ssh folder presence
+ if [[ ! -d $HOME/.ssh ]]; then
+ return
+ fi
+
+ # add default keys if no identities were set up via zstyle
+ # this is to mimic the call to ssh-add with no identities
+ if [[ ${#identities} -eq 0 ]]; then
+ # key list found on `ssh-add` man page's DESCRIPTION section
+ for id in id_rsa id_dsa id_ecdsa id_ed25519 identity; do
+ # check if file exists
+ [[ -f "$HOME/.ssh/$id" ]] && identities+=$id
+ done
+ fi
- # start ssh-agent and setup environment
- /usr/bin/env ssh-agent ${lifetime:+-t} ${lifetime} | sed 's/^echo/#echo/' > ${_plugin__ssh_env}
- chmod 600 ${_plugin__ssh_env}
- . ${_plugin__ssh_env} > /dev/null
+ # get list of loaded identities' signatures and filenames
+ if lines=$(ssh-add -l); then
+ for line in ${(f)lines}; do
+ loaded_sigs+=${${(z)line}[2]}
+ loaded_ids+=${${(z)line}[3]}
+ done
+ fi
- # load identies
- zstyle -a :omz:plugins:ssh-agent identities identities
- echo starting ssh-agent...
+ # add identities if not already loaded
+ for id in $identities; do
+ # check for filename match, otherwise try for signature match
+ if [[ ${loaded_ids[(I)$HOME/.ssh/$id]} -le 0 ]]; then
+ sig="$(ssh-keygen -lf "$HOME/.ssh/$id" | awk '{print $2}')"
+ [[ ${loaded_sigs[(I)$sig]} -le 0 ]] && not_loaded+="$HOME/.ssh/$id"
+ fi
+ done
- /usr/bin/ssh-add $HOME/.ssh/${^identities}
+ [[ -n "$not_loaded" ]] && ssh-add ${^not_loaded}
}
# Get the filename to store/lookup the environment from
-if (( $+commands[scutil] )); then
- # It's OS X!
- _plugin__ssh_env="$HOME/.ssh/environment-$(scutil --get ComputerName)"
-else
- _plugin__ssh_env="$HOME/.ssh/environment-$HOST"
-fi
+_ssh_env_cache="$HOME/.ssh/environment-$SHORT_HOST"
# test if agent-forwarding is enabled
-zstyle -b :omz:plugins:ssh-agent agent-forwarding _plugin__forwarding
-if [[ ${_plugin__forwarding} == "yes" && -n "$SSH_AUTH_SOCK" ]]; then
- # Add a nifty symlink for screen/tmux if agent forwarding
- [[ -L $SSH_AUTH_SOCK ]] || ln -sf "$SSH_AUTH_SOCK" /tmp/ssh-agent-$USER-screen
+zstyle -b :omz:plugins:ssh-agent agent-forwarding _agent_forwarding
-elif [ -f "${_plugin__ssh_env}" ]; then
- # Source SSH settings, if applicable
- . ${_plugin__ssh_env} > /dev/null
- ps x | grep ${SSH_AGENT_PID} | grep ssh-agent > /dev/null || {
- _plugin__start_agent;
- }
+if [[ $_agent_forwarding == "yes" && -n "$SSH_AUTH_SOCK" ]]; then
+ # Add a nifty symlink for screen/tmux if agent forwarding
+ [[ -L $SSH_AUTH_SOCK ]] || ln -sf "$SSH_AUTH_SOCK" /tmp/ssh-agent-$USER-screen
+elif [[ -f "$_ssh_env_cache" ]]; then
+ # Source SSH settings, if applicable
+ . $_ssh_env_cache > /dev/null
+ if [[ $USER == "root" ]]; then
+ FILTER="ax"
+ else
+ FILTER="x"
+ fi
+ ps $FILTER | grep ssh-agent | grep -q $SSH_AGENT_PID || {
+ _start_agent
+ }
else
- _plugin__start_agent;
+ _start_agent
fi
-# tidy up after ourselves
-unfunction _plugin__start_agent
-unset _plugin__forwarding
-unset _plugin__ssh_env
+_add_identities
+# tidy up after ourselves
+unset _agent_forwarding _ssh_env_cache
+unfunction _start_agent _add_identities